DeclareModule CkSecrets
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.l ckAutoSplit(obj.i)
  Declare setCkAutoSplit(obj.i, value.l)
  Declare.l ckCompression(obj.i)
  Declare setCkCompression(obj.i, value.l)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.s ckLocation(obj.i)
  Declare setCkLocation(obj.i, value.s)
  Declare.s ckUncommonOptions(obj.i)
  Declare setCkUncommonOptions(obj.i, value.s)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare.l ckDeleteSecret(obj.i, jsonId.i)
  Declare.i ckDeleteSecretAsync(obj.i, jsonId.i)
  Declare.l ckGetSecretBd(obj.i, jsonId.i, bd.i)
  Declare.i ckGetSecretBdAsync(obj.i, jsonId.i, bd.i)
  Declare.l ckGetSecretJson(obj.i, jsonId.i, jsonOut.i)
  Declare.i ckGetSecretJsonAsync(obj.i, jsonId.i, jsonOut.i)
  Declare.l ckGetSecretSb(obj.i, jsonId.i, sb.i)
  Declare.i ckGetSecretSbAsync(obj.i, jsonId.i, sb.i)
  Declare.s ckGetSecretStr(obj.i, jsonId.i)
  Declare.i ckGetSecretStrAsync(obj.i, jsonId.i)
  Declare.l ckListSecrets(obj.i, json.i, jsonOut.i)
  Declare.i ckListSecretsAsync(obj.i, json.i, jsonOut.i)
  Declare.l ckSaveLastError(obj.i, path.s)
  Declare.l ckSetBootstrapSecret(obj.i, jsonId.i, secretContent.i)
  Declare.l ckUpdateSecretBd(obj.i, jsonId.i, secret.i)
  Declare.i ckUpdateSecretBdAsync(obj.i, jsonId.i, secret.i)
  Declare.l ckUpdateSecretJson(obj.i, jsonId.i, secret.i)
  Declare.i ckUpdateSecretJsonAsync(obj.i, jsonId.i, secret.i)
  Declare.l ckUpdateSecretSb(obj.i, jsonId.i, sb.i)
  Declare.i ckUpdateSecretSbAsync(obj.i, jsonId.i, sb.i)
  Declare.l ckUpdateSecretStr(obj.i, jsonId.i, secret.s)
  Declare.i ckUpdateSecretStrAsync(obj.i, jsonId.i, secret.s)
EndDeclareModule

Module CkSecrets
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.l cklMi(obj.i, arg1.i)
  PrototypeC.i cksMi(obj.i, arg1.i)
  PrototypeC.i ckiMi(obj.i, arg1.i)
  PrototypeC.l cklMii(obj.i, arg1.i, arg2.i)
  PrototypeC.l cklMis(obj.i, arg1.i, arg2.s)
  PrototypeC.i ckiMii(obj.i, arg1.i, arg2.i)
  PrototypeC.i ckiMis(obj.i, arg1.i, arg2.s)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC.i CkSecretsCreate()
  PrototypeC CkSecretsDispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "chilkatPb32.dll")
      CompilerElse
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "chilkatPb.dll")
      CompilerEndIf
    CompilerCase #PB_OS_MacOS
      CompilerIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "libchilkatPbM1.dylib")
      CompilerElse
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "libchilkatPb.dylib")
      CompilerEndIf
    CompilerCase #PB_OS_Linux
      ; Note: The full path of the .so shared library will be required when running from a compiled executable on Linux.
      ; See https://www.purebasic.fr/english/viewtopic.php?t=79882
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "libchilkatPb32.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm32
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm32.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm64.so")
      CompilerElse
        CkSecretsLibId.i = OpenLibrary(#PB_Any, "libchilkatPb.so")
      CompilerEndIf
  CompilerEndSelect
  Global SecretsCreate.CkSecretsCreate = GetFunction(CkSecretsLibId,"CkSecretsU_CreateW")
  Global SecretsDispose.CkSecretsDispose = GetFunction(CkSecretsLibId,"CkSecretsU_DisposeW")
  Global SecretsAutoSplit.cklPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_getAutoSplitW")
  Global SecretsPSetAutoSplit.cklPropSet = GetFunction(CkSecretsLibId,"CkSecretsU_putAutoSplitW")
  Global SecretsCompression.cklPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_getCompressionW")
  Global SecretsPSetCompression.cklPropSet = GetFunction(CkSecretsLibId,"CkSecretsU_putCompressionW")
  Global SecretsDebugLogFilePath.cksPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_debugLogFilePathW")
  Global SecretsPSetDebugLogFilePath.cksPropSet = GetFunction(CkSecretsLibId,"CkSecretsU_putDebugLogFilePathW")
  Global SecretsLastErrorHtml.cksPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_lastErrorHtmlW")
  Global SecretsLastErrorText.cksPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_lastErrorTextW")
  Global SecretsLastErrorXml.cksPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_lastErrorXmlW")
  Global SecretsLastMethodSuccess.cklPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_getLastMethodSuccessW")
  Global SecretsPSetLastMethodSuccess.cklPropSet = GetFunction(CkSecretsLibId,"CkSecretsU_putLastMethodSuccessW")
  Global SecretsLocation.cksPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_locationW")
  Global SecretsPSetLocation.cksPropSet = GetFunction(CkSecretsLibId,"CkSecretsU_putLocationW")
  Global SecretsUncommonOptions.cksPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_uncommonOptionsW")
  Global SecretsPSetUncommonOptions.cksPropSet = GetFunction(CkSecretsLibId,"CkSecretsU_putUncommonOptionsW")
  Global SecretsVerboseLogging.cklPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_getVerboseLoggingW")
  Global SecretsPSetVerboseLogging.cklPropSet = GetFunction(CkSecretsLibId,"CkSecretsU_putVerboseLoggingW")
  Global SecretsVersion.cksPropGet = GetFunction(CkSecretsLibId,"CkSecretsU_versionW")
  Global SecretsDeleteSecret.cklMi = GetFunction(CkSecretsLibId,"CkSecretsU_DeleteSecretW")
  Global SecretsDeleteSecretAsync.ckiMi = GetFunction(CkSecretsLibId,"CkSecretsU_DeleteSecretAsyncW")
  Global SecretsGetSecretBd.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_GetSecretBdW")
  Global SecretsGetSecretBdAsync.ckiMii = GetFunction(CkSecretsLibId,"CkSecretsU_GetSecretBdAsyncW")
  Global SecretsGetSecretJson.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_GetSecretJsonW")
  Global SecretsGetSecretJsonAsync.ckiMii = GetFunction(CkSecretsLibId,"CkSecretsU_GetSecretJsonAsyncW")
  Global SecretsGetSecretSb.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_GetSecretSbW")
  Global SecretsGetSecretSbAsync.ckiMii = GetFunction(CkSecretsLibId,"CkSecretsU_GetSecretSbAsyncW")
  Global SecretsGetSecretStr.cksMi = GetFunction(CkSecretsLibId,"CkSecretsU_getSecretStrW")
  Global SecretsGetSecretStrAsync.ckiMi = GetFunction(CkSecretsLibId,"CkSecretsU_GetSecretStrAsyncW")
  Global SecretsListSecrets.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_ListSecretsW")
  Global SecretsListSecretsAsync.ckiMii = GetFunction(CkSecretsLibId,"CkSecretsU_ListSecretsAsyncW")
  Global SecretsSaveLastError.cklMs = GetFunction(CkSecretsLibId,"CkSecretsU_SaveLastErrorW")
  Global SecretsSetBootstrapSecret.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_SetBootstrapSecretW")
  Global SecretsUpdateSecretBd.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretBdW")
  Global SecretsUpdateSecretBdAsync.ckiMii = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretBdAsyncW")
  Global SecretsUpdateSecretJson.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretJsonW")
  Global SecretsUpdateSecretJsonAsync.ckiMii = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretJsonAsyncW")
  Global SecretsUpdateSecretSb.cklMii = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretSbW")
  Global SecretsUpdateSecretSbAsync.ckiMii = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretSbAsyncW")
  Global SecretsUpdateSecretStr.cklMis = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretStrW")
  Global SecretsUpdateSecretStrAsync.ckiMis = GetFunction(CkSecretsLibId,"CkSecretsU_UpdateSecretStrAsyncW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn SecretsCreate() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn SecretsDispose(obj) : EndProcedure
  Procedure.l ckAutoSplit(obj.i) : ProcedureReturn SecretsAutoSplit(obj) : EndProcedure
  Procedure setCkAutoSplit(obj.i, value.l) : ProcedureReturn SecretsPSetAutoSplit(obj,value) : EndProcedure
  Procedure.l ckCompression(obj.i) : ProcedureReturn SecretsCompression(obj) : EndProcedure
  Procedure setCkCompression(obj.i, value.l) : ProcedureReturn SecretsPSetCompression(obj,value) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(SecretsDebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn SecretsPSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(SecretsLastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(SecretsLastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(SecretsLastErrorXml(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn SecretsLastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn SecretsPSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.s ckLocation(obj.i) : ProcedureReturn PeekS(SecretsLocation(obj)) : EndProcedure
  Procedure setCkLocation(obj.i, value.s) : ProcedureReturn SecretsPSetLocation(obj,value) : EndProcedure
  Procedure.s ckUncommonOptions(obj.i) : ProcedureReturn PeekS(SecretsUncommonOptions(obj)) : EndProcedure
  Procedure setCkUncommonOptions(obj.i, value.s) : ProcedureReturn SecretsPSetUncommonOptions(obj,value) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn SecretsVerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn SecretsPSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(SecretsVersion(obj)) : EndProcedure
  Procedure.l ckDeleteSecret(obj.i, jsonId.i) :  ProcedureReturn SecretsDeleteSecret(obj, jsonId) :  EndProcedure
  Procedure.i ckDeleteSecretAsync(obj.i, jsonId.i) :  ProcedureReturn SecretsDeleteSecretAsync(obj, jsonId) :  EndProcedure
  Procedure.l ckGetSecretBd(obj.i, jsonId.i, bd.i) :  ProcedureReturn SecretsGetSecretBd(obj, jsonId, bd) :  EndProcedure
  Procedure.i ckGetSecretBdAsync(obj.i, jsonId.i, bd.i) :  ProcedureReturn SecretsGetSecretBdAsync(obj, jsonId, bd) :  EndProcedure
  Procedure.l ckGetSecretJson(obj.i, jsonId.i, jsonOut.i) :  ProcedureReturn SecretsGetSecretJson(obj, jsonId, jsonOut) :  EndProcedure
  Procedure.i ckGetSecretJsonAsync(obj.i, jsonId.i, jsonOut.i) :  ProcedureReturn SecretsGetSecretJsonAsync(obj, jsonId, jsonOut) :  EndProcedure
  Procedure.l ckGetSecretSb(obj.i, jsonId.i, sb.i) :  ProcedureReturn SecretsGetSecretSb(obj, jsonId, sb) :  EndProcedure
  Procedure.i ckGetSecretSbAsync(obj.i, jsonId.i, sb.i) :  ProcedureReturn SecretsGetSecretSbAsync(obj, jsonId, sb) :  EndProcedure
  Procedure.s ckGetSecretStr(obj.i, jsonId.i) :  ProcedureReturn PeekS(SecretsGetSecretStr(obj, jsonId)) :  EndProcedure
  Procedure.i ckGetSecretStrAsync(obj.i, jsonId.i) :  ProcedureReturn SecretsGetSecretStrAsync(obj, jsonId) :  EndProcedure
  Procedure.l ckListSecrets(obj.i, json.i, jsonOut.i) :  ProcedureReturn SecretsListSecrets(obj, json, jsonOut) :  EndProcedure
  Procedure.i ckListSecretsAsync(obj.i, json.i, jsonOut.i) :  ProcedureReturn SecretsListSecretsAsync(obj, json, jsonOut) :  EndProcedure
  Procedure.l ckSaveLastError(obj.i, path.s) :  ProcedureReturn SecretsSaveLastError(obj, path) :  EndProcedure
  Procedure.l ckSetBootstrapSecret(obj.i, jsonId.i, secretContent.i) :  ProcedureReturn SecretsSetBootstrapSecret(obj, jsonId, secretContent) :  EndProcedure
  Procedure.l ckUpdateSecretBd(obj.i, jsonId.i, secret.i) :  ProcedureReturn SecretsUpdateSecretBd(obj, jsonId, secret) :  EndProcedure
  Procedure.i ckUpdateSecretBdAsync(obj.i, jsonId.i, secret.i) :  ProcedureReturn SecretsUpdateSecretBdAsync(obj, jsonId, secret) :  EndProcedure
  Procedure.l ckUpdateSecretJson(obj.i, jsonId.i, secret.i) :  ProcedureReturn SecretsUpdateSecretJson(obj, jsonId, secret) :  EndProcedure
  Procedure.i ckUpdateSecretJsonAsync(obj.i, jsonId.i, secret.i) :  ProcedureReturn SecretsUpdateSecretJsonAsync(obj, jsonId, secret) :  EndProcedure
  Procedure.l ckUpdateSecretSb(obj.i, jsonId.i, sb.i) :  ProcedureReturn SecretsUpdateSecretSb(obj, jsonId, sb) :  EndProcedure
  Procedure.i ckUpdateSecretSbAsync(obj.i, jsonId.i, sb.i) :  ProcedureReturn SecretsUpdateSecretSbAsync(obj, jsonId, sb) :  EndProcedure
  Procedure.l ckUpdateSecretStr(obj.i, jsonId.i, secret.s) :  ProcedureReturn SecretsUpdateSecretStr(obj, jsonId, secret) :  EndProcedure
  Procedure.i ckUpdateSecretStrAsync(obj.i, jsonId.i, secret.s) :  ProcedureReturn SecretsUpdateSecretStrAsync(obj, jsonId, secret) :  EndProcedure
EndModule

